Index: include/speex/speex_preprocess.h
===================================================================
--- include/speex/speex_preprocess.h	(revision 14271)
+++ include/speex/speex_preprocess.h	(working copy)
@@ -93,6 +93,8 @@
 */
 int speex_preprocess_ctl(SpeexPreprocessState *st, int request, void *ptr);
 
+/** Resets a denoising state */
+void speex_preprocess_state_reset(SpeexPreprocessState *st);
 
 
 /** Set preprocessor denoiser state */
Index: libspeex/preprocess.c
===================================================================
--- libspeex/preprocess.c	(revision 14271)
+++ libspeex/preprocess.c	(working copy)
@@ -481,7 +481,19 @@
          st->window[i+N3]=1;
       }
    }
-   for (i=0;i<N+M;i++)
+
+   speex_preprocess_state_reset(st);
+
+   return st;
+}
+
+void speex_preprocess_state_reset(SpeexPreprocessState* st)
+{
+   int N, N3, i;
+   N = st->ps_size;
+   N3 = 2*N - st->frame_size;
+
+   for (i=0;i<N+NB_BANDS;i++)
    {
       st->noise[i]=QCONST32(1.f,NOISE_SHIFT);
       st->reverb_estimate[i]=0;
@@ -504,7 +516,7 @@
    st->loudness_weight = (float*)speex_alloc(N*sizeof(float));
    for (i=0;i<N;i++)
    {
-      float ff=((float)i)*.5*sampling_rate/((float)N);
+      float ff=((float)i)*.5*st->sampling_rate/((float)N);
       /*st->loudness_weight[i] = .5f*(1.f/(1.f+ff/8000.f))+1.f*exp(-.5f*(ff-3800.f)*(ff-3800.f)/9e5f);*/
       st->loudness_weight[i] = .35f-.35f*ff/16000.f+.73f*exp(-.5f*(ff-3800)*(ff-3800)/9e5f);
       if (st->loudness_weight[i]<.01f)
@@ -527,7 +539,6 @@
 
    st->nb_adapt=0;
    st->min_count=0;
-   return st;
 }
 
 void speex_preprocess_state_destroy(SpeexPreprocessState *st)
